#!/usr/bin/env ruby

require 'optparse'

options = {}

opt_parser = OptionParser.new do |opt|
	opt.banner = "Usage: bundle_symlinklocalisations_policy [OPTIONS]"
	opt.separator  ""
	opt.separator  "Options"
	
	opt.on("-b", "--bundlePath [PATH]", "the path to the bundle") do |bundle_path|
    	options[:bundlePath] = bundle_path
	end
	
	opt.on("-s", "--symlinkPolicy [POLICY]", "the symlink policy") do |symlink_policy|
    	options[:symlinkPolicy] = symlink_policy
	end
end

opt_parser.parse!

bundle_path = options[:bundlePath]
symlink_policy = options[:symlinkPolicy]

if !bundle_path || !symlink_policy
	puts opt_parser
	exit -1
end

bash_path = "/bin/bash"
symlink_policy = eval(symlink_policy)

resource_location = File.expand_path(File.join(bundle_path, "Resources"))
if !File.directory?(resource_location)
	resource_location = File.expand_path(File.join(bundle_path, "Contents", "Resources"))
end

sdk = File.basename(ENV["SDKROOT"]).downcase

if !File.directory?(resource_location) && sdk.include?("iphone")
	resource_location = bundle_path
end

exit unless File.directory?(resource_location)

symlink_policy.each do |base_directory, source_directory|
	system(bash_path, "-c", "cd '#{resource_location}'; [ -d '#{source_directory}' ] && ln -sfh '#{source_directory}' '#{base_directory}';")
end
